[inherit('sys$library:starlet'),environment] module test(input,output);

type word = [volatile,word] -32768..32767;
     quad = [volatile,quad] record l0 : unsigned; l1 : integer end;
     nametype = [volatile] varying [255] of char;
     esa$type = [volatile] packed array [1..255] of char;

var name : nametype;
    cdt,rdt : quad;
    returnstatus : integer;

[asynchronous,external(sys$fao)] function fao (
	ctrstr : [class_s] packed array [$l1..$u1:integer] of char;
	var outlen : word := %immed 0;
	var outbuf : [class_s] packed array [$l3..$u3:integer] of char;
	p1 : [list] quad) : integer; external; 

function lib$file_scan(fab : fab$type;
                       %immed [unbound] function success(fab : fab$type) : integer;
                       %immed [unbound] function error(fab : fab$type) : integer;
                       context : integer) : integer; external;

function lib$file_scan_end(fab : fab$type; context : integer) : integer; external;

function success(fab : fab$type) : integer;

label 1;

type xab_ref = ^xab$type;
     nam_ref = ^nam$type;
     devicenametype = packed array [1..16] of char;

var status1,status2 : integer;
    fib : [volatile] fib$type;
    devicename : devicenametype;
    attrl : array [1..5] of atr$type;
    channel : [volatile,word] 0..65535;
    iosb : record status : word;
                  len    : word;
                  dummy  : integer;
           end;
    descr : record
       length : word;
       dummy  : word;
       addr   : ^fib$type;
    end;
    i : 1..4;
    
    

procedure checkstatus(status,retstatus : integer);

var msg : record length : word;
                 flags  : word;
                 msg    : unsigned;
          end;
begin
if not odd(status) then begin
   returnstatus:= retstatus;
   goto 1;
end;
end;
  
begin
fib:= (0)::fib$type;

if not fab.fab$l_dev::dev$type.dev$v_dir and
   not fab.fab$l_nam::nam_ref^.nam$v_node then
   checkstatus(ss$_notfiledev,4);

if fab.fab$l_dev::dev$type.dev$v_for then
   checkstatus(ss$_devforeign,4);

if not fab.fab$l_nam::nam_ref^.nam$v_node then
   with fib, fab.fab$l_nam::nam_ref^,descr do begin
      descr.length:= size(fib);
      descr.addr:= address(fib);
      devicename:= nam$t_dvi;
      status1:= $assign(substr(devicename,2,ord(devicename[1])),channel);
      checkstatus(status1,4);
      fib$w_fid:= nam$w_fid;
      for i:= 1 to 2 do attrl[i].atr$w_size:= 8;
      attrl[1].atr$w_type:= atr$c_credate;
      attrl[1].atr$l_addr:= (address(cdt))::unsigned;
      attrl[2].atr$w_type:= atr$c_revdate;
      attrl[2].atr$l_addr:= (address(rdt))::unsigned;
      attrl[3]:= (0)::atr$type;
      status1:= $qiow(,channel,io$_access,iosb,,,%ref descr,,,,%ref attrl,);
      status2:= $dassgn(channel);
      checkstatus(status2,5);
      checkstatus(status1,3);
      checkstatus(iosb.status,3);
   end
else with fab, fab$l_xab::xab_ref^ do begin
      checkstatus(fab$l_sts::integer,2);
      if fab$l_stv <> 0 then
         checkstatus(fab$l_stv::integer,2);
      cdt:= xab$q_cdt;
      rdt:= xab$q_rdt;
   end;
returnstatus:= 1;
1: success:= ss$_normal;
end;



function error(fab : fab$type) : integer;

var msg : record length : word;
                 flags  : word;
                 mess1,mess2 : unsigned;
          end;
    status : integer;
begin
returnstatus:= 2;
error:= ss$_normal;
end;

[global] function getfiledate(name : [volatile,class_s] packed array [$1..$2 : integer] of char;
                  version : integer; var date : quad) : integer;

var fab : fab$type;
    nam : [volatile] nam$type;
    xabdat : [volatile] xab$type;
    context : integer;
    status : integer;
    esa : esa$type;

begin
   fab:= (0)::fab$type;
   nam:= (0)::nam$type;
   xabdat:= (0)::xab$type;
   context:= 0;
   esa:= (0)::esa$type;
   with fab,nam,xabdat do begin
      fab$b_bid:= fab$c_bid;
      fab$b_bln:= fab$c_bln;
      fab$l_fna:= (address(name))::unsigned;
      fab$l_nam:= (address(nam))::unsigned;
      fab$b_fns:= $2;
      fab$l_xab:= (address(xabdat))::unsigned;
      nam$b_bid:= nam$c_bid;
      nam$b_bln:= nam$c_bln;
      nam$l_esa:= (address(esa))::unsigned;
      nam$b_ess:= 255;
      nam$b_nop:= nam$m_srchxabs;
      xab$b_cod:= xab$c_dat;
      xab$b_bln:= xab$c_datlen;
   end;
   status:= lib$file_scan(fab,success,error,context);
   if status = rms$_fnf
      then returnstatus:= 2
   else if not odd(status)
      then returnstatus:= 4;
   status:= lib$file_scan_end(fab,context);
   if odd(status)
      then getfiledate:= returnstatus
      else getfiledate:= 5;
   if odd(version)
      then date:= cdt
      else date:= rdt;
end;
end.
